//________________________________________________________________________________
//
// MonkeyAudio.h
//________________________________________________________________________________
//

// Prevent Multiple Inclusion of MonkeyAudio Header
#ifndef MONKEYAUDIO_H
#define MONKEYAUDIO_H

//#define INITGUID
#include <dmusicc.h>
#include <dmusici.h>
#include <dsound.h>
#include <dshow.h>
#include <cguid.h>
#include <list>
#include <deque>

using namespace std;

#define LOOP	1
#define NO_LOOP	0

#define ALLOC_BUFFERS		16
#define MAX_SOUNDS			60

#define WLD_RAIN_FLOOR		0
#define WLD_RAIN_CANOPY		1
#define WLD_WIND			2
#define WLD_WATER			3
#define WLD_UNDERWATER		4
#define WLD_INSECTS			5
#define WLD_INSECTS2		6
#define WLD_BIRDS			7
#define WLD_BIRDS2			8
#define WLD_OTHER			9
#define WLD_THUNDER			10
#define WLD_THUNDER2		11
#define WLD_THUNDER3		12
#define MNK_RUN_FLOOR		13
#define MNK_RUN_FLOOR2		14
#define MNK_RUN_FLOOR3		15
#define MNK_RUN_FLOOR4		16
#define MNK_RUN_TREE		17
#define MNK_RUN_TREE2		18
#define MNK_RUN_TREE3		19
#define MNK_RUN_TREE4		20
#define MNK_RUN_WATER		21
#define MNK_CLIMB			22
#define MNK_JUMP			23
#define MNK_LAND			24
#define MNK_SUBMERGE		25
#define MNK_DEATH			26
#define MNK_BIRTH			27
#define MNK_SCORE			28
#define MNK_DAMAGE			29
#define	MNK_SENSE			30
#define	MNK_TAUNT			31
#define NET_MSG_LONG		32
#define NET_MSG_SHORT		33
#define	NET_MSG_SHORT2		34
#define	WPN_SLAP_CHANGE		35
#define	WPN_SLAP_FIRE		36
#define WPN_SLAP_CONNECT	37
#define WPN_SHOT_CHANGE		38
#define WPN_SHOT_RELOAD		39
#define WPN_SHOT_FIRE		40
#define WPN_SHOT_RICOCHET	41
#define WPN_BANANA_CHANGE	42
#define WPN_BANANA_RELOAD	43
#define WPN_BANANA_FIRE		44
#define WPN_BANANA_FLY		45
#define	WPN_BANANA_EXPLODE	46
#define WPN_COCO_CHANGE		47
#define WPN_COCO_RELOAD		48
#define WPN_COCO_IDLE		49
#define WPN_COCO_FIRE		50
#define WPN_COCO_FLY		51
#define WPN_COCO_BOUNCE		52
#define WPN_COCO_EXPLODE	53
#define WPN_RAIL_CHANGE		54
#define WPN_RAIL_RELOAD		55
#define WPN_RAIL_FIRE		56
#define NACHO_MAN			57
#define WLD_VICTORY			58
#define POW_MEDKIT			59


typedef struct _AudioPathBuffer {
    IDirectMusicAudioPath8* p3DAudioPath;
	IDirectSound3DBuffer8* pDSB;
    IDirectMusicSegmentState* pSegState;
    void *owner;
    _AudioPathBuffer() {
        p3DAudioPath = NULL;
        pDSB = NULL;
        pSegState = NULL;
        owner = NULL;
    }
} AudioPathBuffer;


class CMonkeyAudio {

    public:
        void PlayAtPlayer( int iSound );
        AudioPathBuffer Play( int iSound, float fX, float fY, float fZ );
		void InitBackground( HWND hWnd );
		void PlayBackground( void );
		void LoadMus( LPCWSTR wszFilename, bool repeats );
		void InitMus( HWND hWnd );
		void PlayMus( );
		void StopMus( );
		void SetVol( long cdb );
		void Stop( AudioPathBuffer &apb, void *who );
		void SetPosition( AudioPathBuffer &apb, void *who, float fx, float fy, float fz );
        CMonkeyAudio();
		~CMonkeyAudio();
		void Update( );
		bool repeats;

    private:
        list<AudioPathBuffer> usedBuffers;
        deque<AudioPathBuffer> freeBuffers;
		void Init();
        static CMonkeyAudio* s_instance;
		WCHAR *wszSounds[MAX_SOUNDS];
		IDirectMusicLoader8* m_pLoader;
		IDirectMusicPerformance8* m_pPerformance;
		IDirectMusicSegment8* m_pSegments[MAX_SOUNDS];
		IDirectMusicAudioPath8* m_pMusicPath;
		IDirectSound3DListener8* pListener;
		IBaseFilter* m_pMP3;

};

#endif
